<script setup>
import ApexCharts from "apexcharts";
import { ref, onMounted, defineProps  } from "vue";
const props = defineProps(["variables"]);

const areaChart = ref(null);

onMounted(() => {
  // Move your ApexCharts script logic here


  const areaChartColors = getChartColorsArray("area-chart");
  if (areaChartColors) {
    const options = {
      series: [
        { name: "Sanciones", data: props.variables?.meses.map((meses) => meses.sanciones) || [] },
      ],
      chart: {
        height: 350,
        type: "area",
        toolbar: { show: false },
      },
      colors: areaChartColors,
      dataLabels: { enabled: false },
      stroke: { curve: "smooth", width: 2 },
      fill: {
        type: "gradient",
        gradient: {
          shadeIntensity: 1,
          inverseColors: false,
          opacityFrom: 0.45,
          opacityTo: 0.05,
          stops: [20, 100, 100, 100],
        },
      },
      xaxis: { categories: props.variables?.meses.map((meses) => meses.mes) || [] },
      markers: { size: 3, strokeWidth: 3, hover: { size: 4, sizeOffset: 2 } },
      legend: { position: "top", horizontalAlign: "right" },
    };

    const chart = new ApexCharts(areaChart.value, options);
    chart.render();
  }

  // Your new script logic for column_chart_datalabel
  const columnChartDatalabelColors = getChartColorsArray("column_chart_datalabel");
  const sancionesServidores = ref(props.variables?.instituciones);
  if (columnChartDatalabelColors) {
    const options = {
      chart: {
        height: 350,
        type: "bar",
        toolbar: { show: true },
      },
      plotOptions: {
        bar: {
          dataLabels: { position: "top" },
        },
      },
      dataLabels: {
        enabled: true,
        formatter: function (e) {
          return e + "";
        },
        offsetY: -22,
        style: {
          fontSize: "12px",
          colors: ["#304758"],
        },
      },
      series: [
        { name: "Sanciones", data: props.variables?.institucionesDependencias.map((institucion) => institucion.sancionesCount) || [] },
      ],
      colors: columnChartDatalabelColors,
      grid: { borderColor: "#f1f1f1" },
      xaxis: {
        categories: props.variables?.institucionesDependencias.map((institucion) => institucion.nombre) || [],
        position: "top",
        
        axisBorder: { show: true },
        axisTicks: { show: true },
        crosshairs: {
          fill: {
            type: "gradient",
            gradient: {
              colorFrom: "#D8E3F0",
              colorTo: "#BED1E6",
              stops: [0, 100],
              opacityFrom: 0.4,
              opacityTo: 0.5,
            },
          },
        },
        tooltip: { enabled: false, offsetY: -35 },
      },
      fill: {
        gradient: {
          shade: "light",
          type: "horizontal",
          shadeIntensity: 0.25,
          gradientToColors: null,
          inverseColors: true,
          opacityFrom: 1,
          opacityTo: 1,
          stops: [50, 0, 100, 100],
        },
      },
      yaxis: {
        axisBorder: { show: true },
        axisTicks: { show: true },
        labels: {
          show: true,
          formatter: function (e) {
            return e + "";
          },
        },
      },
      title: {
        text: "Sanciones emitidas",
        floating: true,
        offsetY: 330,
        align: "center",
        style: { color: "#444", fontWeight: "500" },
      },
    };

    const chart = new ApexCharts(document.querySelector("#column_chart_datalabel"), options);
	
    chart.render();

	const columnChartDatalabel = document.getElementById("column_chart_datalabel");
    if (columnChartDatalabel) {
      const tspans = columnChartDatalabel.querySelectorAll("tspan");
      tspans.forEach(tspan => {
        tspan.style.display = "none";
      });
    }

  }
});

function getChartColorsArray(id) {
  const element = document.getElementById(id);
  if (element) {
    const colorsAttribute = element.getAttribute("data-colors");
    if (colorsAttribute) {
      const colors = JSON.parse(colorsAttribute);
      return colors.map((color) => {
        const trimmedColor = color.replace(" ", "");
        if (trimmedColor.indexOf(",") === -1) {
          const computedColor = getComputedStyle(document.documentElement).getPropertyValue(trimmedColor);
          return computedColor || trimmedColor;
        }
        const colorArray = color.split(",");
        return colorArray.length !== 2 ? color : `rgba(${getComputedStyle(document.documentElement).getPropertyValue(colorArray[0])},${colorArray[1]})`;
      });
    }
    console.warn("data-colors Attribute not found on:", id);
  }
  return null;
}
</script>


<script>

	import { inject } from 'vue';

	export default {
	  
	  setup(props) {
	  const csrf = inject('csrf');

    
    

	  return {
	    csrf,
	  };
	},
	  data() {

	    return {

			sancionesParticulares: this.variables?.widgets?.particularesSancionados,
			sancionesServidores: this.variables?.widgets?.servidoresPublicosSancionados,
			sancionesTotales: this.variables?.widgets?.sancionesCount,
			sancionesEstaSemana: this.variables?.widgets?.estaSemana,
			sancionesEsteMes: this.variables?.widgets?.esteMes,
			sancionesEsteAño: this.variables?.widgets?.esteAnio,
			instituciones: this.variables?.institucionesDependencias,
       
        


	    }
	  },
	  props: {
	    variables: Object,
      
	},
	watch: {
	

	},





  


	}

</script>




<template>
	<div class="main-content">

		<div class="page-content">
			<div class="container-fluid">

				<div class="row">

					<div class="col-xl-8">
						<div class="row">
							<div class="col-lg-6">
								<div class="card mini-stats-wid">
									<div class="card-body">
										
										<div class="d-flex flex-wrap">
											<div class="me-3">
												<p class="text-muted mb-2">Sanciones a servidores publicos</p>
												<h5 class="mb-0">{{sancionesServidores}}</h5>
											</div>

											<div class="avatar-sm ms-auto">
												<div class="avatar-title bg-light rounded-circle text-primary font-size-20">
													<i class="bx bxs-book-bookmark"></i>
												</div>
											</div>
										</div>

									</div>
								</div>
							</div>
							
							<div class="col-lg-6">
								<div class="card blog-stats-wid">
									<div class="card-body">

										<div class="d-flex flex-wrap">
											<div class="me-3">
												<p class="text-muted mb-2">Sanciones a particulares</p>
												<h5 class="mb-0">{{sancionesParticulares}}</h5>
											</div>

											<div class="avatar-sm ms-auto">
												<div class="avatar-title bg-light rounded-circle text-primary font-size-20">
													<i class="bx bxs-note"></i>
												</div>
											</div>
										</div>
										
									</div>
								</div>
							</div>
							
						</div>
						<!-- end row -->

						<div class="card">
							<div class="card-body">
								<div class="d-flex flex-wrap align-items-start">
									<h5 class="card-title me-2">Sanciones emitidas</h5>
									<div class="ms-auto">
										<div class="toolbar d-flex flex-wrap gap-2 text-end">
											
											
										</div>
									</div>
								</div>

								<div class="row text-center">
									<div class="col-lg-4">
										<div class="mt-4">
											<p class="text-muted mb-1">Esta semana</p>
											<h5>{{sancionesEstaSemana}}</h5>
										</div>
									</div>
									
									<div class="col-lg-4">
										<div class="mt-4">
											<p class="text-muted mb-1">Este mes</p>
											<h5>{{sancionesEsteMes}}</h5>
										</div>
									</div>

									<div class="col-lg-4">
										<div class="mt-4">
											<p class="text-muted mb-1">Este año</p>
											<h5>{{sancionesEsteAño}}</h5>
										</div>
									</div>
								</div>

								<hr class="mb-4">
								
								<div class="apex-charts" data-colors='["--bs-primary", "--bs-warning"]' ref="areaChart" id="area-chart" dir="ltr"></div>
							</div>
						</div>
					</div>
					<!-- end col -->

					<div class="col-xl-4">
						<div class="card">
							<div class="card-body">
								<div class="d-flex flex-wrap align-items-start">
									<h5 class="card-title mb-3 me-2">Sanciones totales</h5>

								
								</div>

								<div class="d-flex flex-wrap">
									<div>
										<p class="text-muted mb-1">Total</p>
										<h4 class="mb-3">{{sancionesTotales}}</h4>
									</div>
									<div class="ms-auto align-self-end">
										<i class="bx bx-group display-4 text-light"></i>
									</div>
								</div>
							</div>
						</div>

					

						<div class="card" style="height: 72%;">
							<div class="card-body">
								<h4 class="card-title mb-4">Sanciones por institucion</h4>
								
								<div ref="columnChartDatalabel" data-colors='["--bs-primary"]' class="apex-charts" id="column_chart_datalabel" dir="ltr"></div>						</div>
						</div><!--end card-->
					</div>
					<!-- end col -->

				</div>
				<!-- end row -->

				
				
			</div> <!-- container-fluid -->
		</div>
		<!-- End Page-content -->

		
		
	</div>
</template>


<style>
	#BuscarCP{
	  width: 80px;
	  height: 34px;
	}
	
	#nuevoSancion{
	  height: 40px;
	}
	
	.btn-primary-check{
	  background-color: #556ee6;
	  color: white !important;
	}

  .multiselect-tag{
    background: #6045ca;
  }
	
	.multiselect-wrapper {
	    height: 10px;
	    padding: .47rem 1.75rem .47rem .75rem;
	    font-size: .8125rem;
	}
	
	.tipoSancion {
	  height: 70px
	}

 
	
	.dashed-line {
	    border-top: 1px solid  #e6e3e3;
	    margin-top: 20px; /* Ajusta la separación si es necesario */
	}

  .dashed-line-row {
    border-top: 1px solid  #e6e3e3;
    margin-top: 20px;
    width:98%;
}
</style>